// GDIAPP.CPP: Shows how to use the TDC class to draw shapes, icons, and bitmaps.
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream.h>

#include <owl\opensave.h>

#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dc.h>


#include "ani.rc"

// The shape modes.
enum TShapeMode { mBitmap };
// The program operation modes.
enum TOptionMode { DRAW, START, GET };


class TApp : public TApplication 		// application class
{
public:
	TApp() : TApplication() {}
	void InitMainWindow();
};

class TWndw : public TFrameWindow		// main window class
{
protected:

	TShapeMode shape;
	TOptionMode operation;
	TPoint OldPoint;
	TBitmap *Bg ;
	TBitmap *Decore1 ;
	TBitmap *Decore2 ;
	TBitmap *GWorld  ;
	TBitmap *HBalk   ;
	TBitmap *HBut    ;
	TIcon *GDIIcon;
	int Decore,timer,t,Tile_rij,Tile_Colm,lastt,Butpos,Oldpos;
	BYTE Tiles[5001];
	FILE *bestand;


public:
	TWndw( TWindow *parent, const char far *title );

	TOpenSaveDialog::TData   FilenameData;
	TOpenSaveDialog::TData   FilenameData2;

protected:

	void SetupWindow();
	void CleanUpWindow();
	void Paint( TDC&, BOOL, TRect& );
	void CmManual();
	void CmAuto();
	void CmTest();
	void CmNew();
	void CmLt();
	void CmLw();
	void CmSw();
	void EvLButtonDown( UINT, TPoint &point );
	void EvRButtonDown( UINT, TPoint& );
	void EvTimer( UINT );
	void EvChar( UINT, UINT, UINT );
	void CmDecore1();
	void CmDecore2();

private:
	void DrawObject( );
	DECLARE_RESPONSE_TABLE( TWndw );
};

DEFINE_RESPONSE_TABLE1( TWndw, TFrameWindow )
	EV_WM_LBUTTONDOWN,
	EV_WM_RBUTTONDOWN,
	EV_WM_TIMER,
	EV_WM_CHAR,
	EV_COMMAND( CM_MANUAL, CmManual ),
	EV_COMMAND( CM_AUTO, CmAuto ),
	EV_COMMAND( CM_TEST, CmTest ),
	EV_COMMAND( CM_NEW,CmNew)   ,

	EV_COMMAND( CM_LT,CmLt)    ,
	EV_COMMAND( CM_LW,CmLw)    ,
	EV_COMMAND( CM_SW,CmSw)    ,
	EV_COMMAND( CM_DECORE1,CmDecore1)    ,
	EV_COMMAND( CM_DECORE2,CmDecore2)    ,

	END_RESPONSE_TABLE;

// main window's constructor.

TWndw::TWndw( TWindow *parent, const char far *title ) :
			TFrameWindow( parent, title ),
				TWindow(parent, title),
				FilenameData (OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,
				"World Files (*.bin)|*.bin|All Files (*.*)|*.*|",
				 0, "", "*"),
				FilenameData2 (OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST,
				"BMP Files (*.bmp)|*.bmp|All Files (*.*)|*.*|",
				 0, "", "*")

{
	Attr.X = 0; 				// Position and size the window.
	Attr.Y = 0;
	Attr.W = 800;
	Attr.H = 600;
	Attr.Style = WS_BORDER | WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE;
	AssignMenu( GDIMENU ); 			// Add the menu to the window.
	SetIcon( GetApplication(), GDIICON ); 	// Set the application's icon.
	shape = mBitmap; 			// Initialize the shape and operation modes.
	operation = START;
	Decore = 1 ;
	t=0;Tile_rij=0,Butpos=0;
	for (int xp=0;xp<5000;xp++) Tiles[xp]=0; // De wereld is Clear

}

// This function, which overrides a function inherited from TFrameWindow, performs
// last-minute set up for a window.
void TWndw::SetupWindow()
{
	TFrameWindow::SetupWindow();		// Always call the base class's SetupWindow()!
	HINSTANCE instance = *GetApplication(); 	// Get the application's instance handle.
	Decore1 = new TBitmap( instance, GDIBMP1 ); 	// construct the bitmap and icon objects.
	Decore2 = new TBitmap( instance, GDIBMP2 );
	HBalk = new TBitmap( instance, HBALK ); 	// construct the bitmap and icon objects.
	HBut = new TBitmap( instance, HBUT ); 	// construct the bitmap and icon objects.
	GDIIcon = new TIcon( instance, GDIICON );
	Bg = new TBitmap( instance, BACKG );

	timer = SetTimer( 1, 10, 0 ); 			// Set up a Windows timer.
	if ( timer == 0 )
		MessageBox( "No timers!", "Error", MB_OK );
}

// last-minute clean-up

void TWndw::CleanUpWindow()
{
	delete Decore1;		// Delete the GDI objects.
	delete Decore2;
	delete GDIIcon;
	delete Bg ;
	delete GWorld ;
	delete HBalk ;
	KillTimer( timer ); 		// Get rid of the game's timer.
}

// This function, which responds to the WM_PAINT message, is called whenever the
// client window needs repainting.
void TWndw::Paint( TDC& paintDC, BOOL, TRect& )
{
	paintDC.SelectStockObject( GRAY_BRUSH ); 	// Select a gray brush.
	TRect rect = GetClientRect();			// Get the size of the client area.
	paintDC.Rectangle( rect ); 		// Erase the client area with a gray rectangle.
}


void TWndw::CmNew()
{
	for (int xp=0;xp<5000;xp++) Tiles[xp]=0; // De wereld is Clear
	operation = START;
	Butpos = 0;
}

void TWndw::CmLt()
{
  if (TFileOpenDialog(this, FilenameData2).Execute() != IDOK) {
	 if (FilenameData.Error != 0) {   // 0 value means user selected Cancel
		char  msg[50];
		sprintf(msg, "GetOpenFileName returned Error #%ld", FilenameData.Error);
		MessageBox(msg, "WARNING", MB_OK|MB_ICONSTOP);
	 }
  }

//HBITMAP LoadBitmap(GDIBMP) const;

}



void TWndw::CmLw()
{
  if (TFileOpenDialog(this, FilenameData).Execute() != IDOK) {
	 if (FilenameData.Error != 0) {   // 0 value means user selected Cancel
		char  msg[50];
		sprintf(msg, "GetOpenFileName returned Error #%ld", FilenameData.Error);
		MessageBox(msg, "WARNING", MB_OK|MB_ICONSTOP);
	 }
  }

bestand=fopen(FilenameData.FileName,"r");
for (int i =0;i<5000;i++ )
	Tiles[i]=fgetc(bestand);
	fclose(bestand);

operation = START;


}

void TWndw::CmDecore1()     // decore 1
{
	Decore = 1;
	operation = START;

}

void TWndw::CmDecore2()     // docore 2
{
	Decore = 2;
	operation = START;

}







// This function is called when the user selects the Option menu's Manual command,
// setting the program's operation mode to manual.
void TWndw::CmManual()     // frame 4 frame
{
//	Invalidate();
	operation = DRAW;
}

// This function is called when the user selects the Option menu's Automatic command,
// setting the program's operation mode to automatic.

void TWndw::CmAuto()
{
	operation = START;

}


// This function responds to a left mouse-button press drawing the current shape
// if the program is in manual operation mode.

void TWndw::EvLButtonDown( UINT, TPoint &point )
{
int xp = point.x; // Calculate screen location.
int yp = point.y;


if ( (xp >= 5) && (xp <= (722+5) ) && (  yp >= (5+25*16+5)) && (yp <= (5+25*16+5+16)))   // Mouse pointer zit in de X balk
{


		Oldpos = Butpos;
		Butpos = xp-5-32-8; // opgelet butpos zijn pixels !!!!!!

		if ((Butpos>0) && (Butpos < Oldpos))  // Klikken Lnks van button
			{
			Butpos = Oldpos -(44*4.2) ;   // Tab links
			if (Butpos < 0) Butpos = 0;
			}

		if ((Butpos<648) && (Butpos > Oldpos))  // Klikken rechts van button
			{
			Butpos = Oldpos +(44*4.2) ;   // Tab rechts
			if (Butpos > 648) Butpos = 648;
			}

		if (Butpos<0) // Klikken op links pijltje = 1/145 van 648 springen naar links
			{
			Butpos = Oldpos-4.2  ;    // stap links
			if (Butpos < 0) Butpos = 0;
			}

		if (Butpos>648) // Klikken op links pijltje = 1/145 van 648 springen naar links
			{
			Butpos = Oldpos + 4.2 ;     //stap rechts
			if (Butpos > 648) Butpos = 648;
			}

			// Debuging

/*		char buffer[80];
		sprintf(buffer, "Butpos : %d  \nTile: %d ",Butpos,t);
		MessageBox( buffer, "Position", MB_OK );
*/

		{
			TClientDC clientDC( HWindow );	// Get a device context for the window's client area.
			
			TMemoryDC memDC( clientDC );
			memDC.SelectObject( *HBalk );
			clientDC.BitBlt(5+32+Oldpos,5+25*16+5,16,15,memDC,(100),(0),SRCCOPY);
			memDC.SelectObject( *HBut );
			clientDC.BitBlt(5+32+Butpos,5+25*16+5+1,12,13,memDC,(0),(0),SRCCOPY);

			if (Decore == 1) memDC.SelectObject( *Decore1 );
			if (Decore == 2) memDC.SelectObject( *Decore2 );

		 for (int xloc=0+Butpos/4.2;xloc<45+Butpos/4.2;xloc++)
		 for (int yloc = 0; yloc< (25 );yloc++)
			{
			int Xx=Tiles[xloc+yloc*200] ;
			clientDC.BitBlt((xloc-Butpos/4.2 )*16+5,((yloc )*16+5),16,16,memDC,(Xx%20)*16,(Xx/20)*16,SRCCOPY);
			}
		}
}


if ((  xp >= 5 ) && ( xp <= (45*16+5) ) && (  yp >= 5) && (yp <= (5 + 16 * 25 )))
																				// Mouse pointer zit in de PACK Dude World balk
	{
		int WWPos = Butpos/4.2;  // Moet nog ingevuld worden !
		int tx = (xp-5) / 16 ;
		int ty = (yp-5) / 16 ;

		TClientDC clientDC( HWindow );	// Get a device context for the window's client area.
		TMemoryDC memDC( clientDC );

		if (Decore == 1) memDC.SelectObject( *Decore1 );
		if (Decore == 2) memDC.SelectObject( *Decore2 );

			{
			Tiles[ty*200+tx+WWPos] = t ;
			clientDC.BitBlt((tx )*16+5,((ty )*16+5),16,16,memDC,(t%20)*16,(t/20)*16,SRCCOPY);  // hier geen correctie !!!!!
			}

	}




if ((  xp >= 5 ) && ( xp <= (40*16+5) ) && (  yp >= 430) && (yp <= (430 + 112)))   // Mouse pointer zit in de X balk
	{

		int tx = (xp-5) / 16 ;
		int ty = (yp-430) / 16 ;

		TClientDC clientDC( HWindow );	// Get a device context for the window's client area.
		
		TMemoryDC memDC( clientDC );
		if (Decore == 1) memDC.SelectObject( *Decore1 );
		if (Decore == 2) memDC.SelectObject( *Decore2 );


		int ttx = 0,tty = 0 ;
		if (tx > 19)
				{
				ttx = tx - 20;
				tty = ty + 7 ;
				}
		else
				{
				ttx = tx ;
				tty = ty;
				}

		t= ttx + tty * 20 ;

		if (t >= 255) t=lastt ; // History of selected Tile

		lastt = t ;             // History of selected Tile

		if (t == 140)
				{
				Tile_rij=20*16;
				Tile_Colm=7*16;
				}

		// From Help file
		//
		//StretchBlt(int dstX, int dstY, int dstW, int dstH, const TDC&
		//srcDC, int srcX, int srcY, int srcW, int srcH, uint32 rop=SRCCOPY);

		clientDC.StretchBlt(
		 800-32-32,
		 0+16,
		 32+16,
		 32+16,   // frame grootte moet hier nog door gegeven worden
		memDC, (16*(t%20)), (16*(t/20)),16,16, SRCCOPY );
		operation = DRAW;
	}


}

// This function responds to a right mouse-button press, calling Invalidate() to
// erase the entire client window.
void TWndw::EvRButtonDown( UINT, TPoint &point )
{
//	Invalidate();
int xp = point.x; // Calculate screen location.
int yp = point.y;

int oldt = t; t=0   ;


if ((  xp >= 5 ) && ( xp <= (45*16+5) ) && (  yp >= 5) && (yp <= (5 + 16 * 25 )))
																				// Mouse pointer zit in de PACK Dude World balk
	{
		int WWPos = Butpos/4.2;  // Moet nog ingevuld worden !
		int tx = (xp-5) / 16 ;
		int ty = (yp-5) / 16 ;

		TClientDC clientDC( HWindow );	// Get a device context for the window's client area.
		TMemoryDC memDC( clientDC );

		if (Decore == 1) memDC.SelectObject( *Decore1 );
		if (Decore == 2) memDC.SelectObject( *Decore2 );
			{
			Tiles[ty*200+tx+WWPos] = t ;
			clientDC.BitBlt((tx )*16+5,((ty )*16+5),16,16,memDC,(t%20)*16,(t/20)*16,SRCCOPY);  // hier geen correctie !!!!!
			}

	}
t = oldt;

}




// This function responds to a WM_CHAR message, which Windows sends to a window
// when the user presses a key.
void TWndw::EvChar( UINT, UINT, UINT )
{
//	Invalidate();
}

// This function responds to WM_TIMER messages.
void TWndw::EvTimer( UINT )
{
	// Draw object only if the program is in the automatic mode and window is not minimized.
	if ( ( operation == START ) && ( !IsIconic() ) )  {
		DrawObject(  );; // Draws the object.
	}
}

// This function draws the currently selected shape at the
// coordinates given in the TPoint object point.


void TWndw::CmTest()
{
		// Ik ga hier eens proberen om een map te tekenen

		TClientDC clientDC( HWindow );	// Get a device context for the window's client area.
		TMemoryDC memDC( clientDC );

		if (Decore == 1) memDC.SelectObject( *Decore1 );
		if (Decore == 2) memDC.SelectObject( *Decore2 );

		int WWPos = Butpos / 5;
		for (int xloc=0+WWPos;xloc<45+WWPos;xloc++)
		 for (int yloc = 0; yloc< (25 );yloc++)
			{
			t=Tiles[xloc+yloc*200] ;
			clientDC.BitBlt((xloc-WWPos )*16+5,((yloc )*16+5),16,16,memDC,(t%20)*16,(t/20)*16,SRCCOPY);
			}
}


void TWndw::DrawObject()     // INIt
{
	TClientDC clientDC( HWindow );	// Get a device context for the window's client area.
	
	TMemoryDC memDC( clientDC );
			 // Select the bitmap into the memory DC.
	memDC.SelectObject( *Bg );
	clientDC.BitBlt(
		 0 ,
		 0 ,
		 799,
		 599,   // frame grootte moet hier nog door gegeven worden
		memDC,
		 0,
		 0,     // Pos van de Background
		  SRCCOPY );


		if (Decore == 1) memDC.SelectObject( *Decore1 );
		if (Decore == 2) memDC.SelectObject( *Decore2 );
			 // Get the bitmap's attributes.



	clientDC.StretchBlt(
		 800-32-32,
		 0+16,
		 32+16,
		 32+16,   // frame grootte moet hier nog door gegeven worden
		memDC, (16*(t%20)), (16*(t/20)),16,16, SRCCOPY );


	Tile_Colm=0;Tile_rij=0;  	//reset Selector-Bar

	for (int xtx=0;xtx<=255;xtx++ )  		// Alle Tiles tekenen
		 {

			if (xtx >= 140)    		// Na 8 rijen volgende kolom
				{
					Tile_rij=20*16;
					Tile_Colm=7*16;
				} else {Tile_Colm=0;Tile_rij=0;}

		clientDC.BitBlt(
		 (5+Tile_rij+((xtx%20))*16) ,
		 (430+(xtx/20)*16)-Tile_Colm ,
		  16,
		  16,   // frame grootte moet hier nog door gegeven worden
		  memDC,
		 (16*(xtx%20)),
		 (16*(xtx/20)),
		  SRCCOPY );
		  }

		if (Decore == 1) memDC.SelectObject( *Decore1 );
		if (Decore == 2) memDC.SelectObject( *Decore2 );

		int WWPos = Butpos / 4.2;
		for (int yloc=0;yloc<25;yloc++)
		 for (int xloc = WWPos; xloc< (45 + WWPos);xloc++)
			{
			xtx=Tiles[yloc*200+xloc] ;
			clientDC.BitBlt((xloc-WWPos)*16+5,((yloc )*16+5),16,16,memDC,(xtx%20)*16,(xtx/20)*16,SRCCOPY);
			}


		memDC.SelectObject( *HBalk );

		clientDC.BitBlt(5,5+25*16+5,721,15,memDC,(0),(0),SRCCOPY);

		memDC.SelectObject( *HBut );

		clientDC.BitBlt(5+32+Butpos,5+25*16+5+1,721,15,memDC,(0),(0),SRCCOPY);

	operation = DRAW;

}


void TWndw::CmSw()
{

  if (TFileSaveDialog(this, FilenameData).Execute() != IDOK) {
	 if (FilenameData.Error != 0) {   // 0 value means user selected Cancel
		char  msg[50];
		sprintf(msg, "GetOpenFileName returned Error #%ld", FilenameData.Error);
		MessageBox(msg, "WARNING", MB_OK|MB_ICONSTOP);
	 }
  }

bestand=fopen(FilenameData.FileName,"wb");
for (int i =0;i<5000;i++ )
	fputc(Tiles[i],bestand)  ;
	fclose(bestand);

}

// This function creates the application's main window.
void TApp::InitMainWindow()
{
	TFrameWindow *wndw = new TWndw( 0, "The Pack Dude Game World Editor             By Piet Goedemans  3Ea / OT" );
	SetMainWindow(wndw);
}

int OwlMain( int, char*[] )
{
  return TApp().Run();
}

